function d=calc_LBFGS(ite, gamma_k, vs, vy, rho, v)

n=size(vs);
nv=n(2);
d=v;

mitev=min(nv, ite);
sigma=zeros(mitev,1);

for l=mitev:-1:1
    i=l+ite-mitev;
    j=mod(i-1,nv)+1;
    sigma(l)=rho(j)*vs(:,j)'*d;
    d=d-sigma(l)*vy(:,j);
end

d=gamma_k*d;

for l=1:mitev
    i=l+ite-mitev;
    j=mod(i-1,nv)+1;
    bsigma=rho(j)*vy(:,j)'*d;
    d=d+(sigma(l)-bsigma)*vs(:,j);
end

