function [xp, cf, nfp,ite,n_f, ctime]=MLBFGS(fname,gname,x0,method,display)

ctime=cputime;
n=length(x0);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ʂ̏ݒ@@@@@@@@@@@@@@@@@%@@ 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
eps=n*10^-8; % I \| \nabla f(x_k) \|<eps

xp=x0; %̔_

nfp=feval(gname,xp); %xp ɂz
cf=feval(fname,xp); %xpɂړI֐l

n_f=1;
ite=0;



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% L-BFGS ̏                                   %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
nv=5; % L-BFGS̋LxNg̐
vs=zeros(n,nv);  % s_i Lz
vy=zeros(n,nv);  % y_i Lz
rho=zeros(nv,1); % rho_i Lz
gamma_k=1;  % XP[Opp[^
gamma_km=1; % XP[Opp[^
l=n-1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%
% L-BFGS
%%%%%%%%%%%%%%%%%%%%%%%%%%%
if method==1
    while norm(nfp)>eps && ite<10000
        
        x=xp;
        nf=nfp;
        
        if display==1
            fprintf('LBFGS: ');
        end
        d=-calc_LBFGS(ite, gamma_k, vs, vy, rho, nf);
        
        
        [t, cf, nfp, n_fw]=wolfe(x, d, nf,cf, fname, gname); % wolfȅ݂XebvvZ
        n_f=n_f+n_fw;
        xp=x+t*d;
        ite=ite+1;
        
        s=xp-x;
        y=nfp-nf;
        
        gamma_k=gamma_km;
        gamma_km=(s'*y)/(y'*y);
        itev=mod(ite-1,nv)+1;
     
        vs(:,itev)=s;
        vy(:,itev)=y;
        if s'*y<10^-10
            rho(itev)=10^-10;
        else
            rho(itev)=1/(s'*y);
        end
        
        if display==1
            fprintf('norm(nfp)=%f, ite=%d, f=%f, t=%f, n_f=%d \n', norm(nfp),ite, cf,t,n_f);
        end
    end
    
    ctime=cputime-ctime;
    return
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  bH: \bar H_k ̃f[^. ΊpƑт̗vf
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
bH1=ones(n,1); % sPʍsɂD
bH2=zeros(n-1,1);

iteM=0;

check_LBFGS=1; % ݔŎgpĂ@(1: LBFGS, ȊO: MLBFGS)
LN = 20; % ͂߂LN͕KLBFGS@g

MLC=5; %min(nv-2,nv);

while norm(nfp)>eps && ite<50000
    
    x=xp;
    nf=nfp;
    
    if check_LBFGS==1 || ite< LN
        if display==1
            fprintf('LBFGS: ');
        end
        d=-calc_LBFGS(ite, gamma_k, vs, vy, rho, nf);
    else
        if display==1
            fprintf('MBFGS: ');
        end
        d=-calc_lHv(ite, vs, vy, rho, nf,l,bH1,bH2, MLC);
    end
    
    [t, cf, nfp, n_fw]=wolfe(x, d, nf,cf, fname, gname); % wolfȅ݂XebvvZ
    n_f=n_f+n_fw;
    xp=x+t*d;
    
    if t<1.0  || gamma_k*norm(nfp)> norm(d) % XebvCTƂ
        iteM=0;
        check_LBFGS=1;
    end
    
    ite=ite+1;
    iteM=iteM+1;
    
    s=xp-x;
    y=nfp-nf;
    
    gamma_k=gamma_km;
    gamma_km=(s'*y)/(y'*y);
    itev=mod(ite-1,nv)+1;
    
    if ite>nv
        itev2=mod(ite-1+MLC,nv)+1;
    else
        itev2=max(1,ite-nv+MLC);
    end
    if ite>nv-MLC
        s2=vs(:,itev2);
        y2=vy(:,itev2);
    end
    vs(:,itev)=s;
    vy(:,itev)=y;
    if s'*y<10^-10
        rho(itev)=10^-10;
    else
        rho(itev)=1/(s'*y);
    end
    
    if iteM<=nv-MLC %XP[O H_{k-m}=\gamma_k * I
        bH2=zeros(n-1,1);
        bH1=gamma_k*ones(n,1); % sPʍsɂD
    else % MCQN@ōs H_{k-m} vZ
        if check_LBFGS==1 && nv==MLC
            bH2=zeros(n-1,1);
            bH1=gamma_k*ones(n,1);
        end
        check_LBFGS=0;
        s=s2;
        y=y2;
        
        sy=s'*y;
        if sy>0.001*eps^2
            Hy=calc_Hv(n,l,bH1,bH2,y);
            yHy=y'*Hy;
            rho2=(1+yHy/sy)/sy;
       
            bH2=rho2*s(1:n-1).*s(2:n)-(Hy(1:n-1).*s(2:n)+Hy(2:n).*s(1:n-1))/sy+bH2;
            bH1=rho2*s.^2-(2/sy)*Hy.*s+bH1;
            
        end
    end
    if display==1
        fprintf('norm(nfp)=%f, ite=%d, f=%f, t=%f, n_f=%d \n', norm(nfp),ite, cf,t,n_f);
    end
end

ctime=cputime-ctime;